*! version 6.0.1  09jun1999  
program define arima_dr
	version 6
	args 	    todo	/*  whether to calculate gradient
		*/  bc		/*  Name of full beta matrix
		*/  llvar	/*  Name of variable to hold LL_t */

	tempname sigma2 F v1 Q Ap H XI R w P Qvec Pvec sumRho
	tempvar ApX y_pred y_mse    /* y_mse returned by kalman but not used */

				/* handle contraints, if any */
	if "$TT" != "" {
		tempname b
		mat `b' = `bc' * $TT' + $Ta
		mat colnames `b' = $Tstripe
	}
	else	local b `bc'

	qui gen double `y_pred' = . in 1
	qui gen double `y_mse' = . in 1

	scalar `sigma2' = `b'[1, colsof(`b')]^2

	kalarma1 `F' `v1' `Q' `Ap' `H' `XI' `R' `w' : `b' `sigma2'

				/* Inital conditions for filter */

	if "$Tstate0" != "" { mat `XI' = $Tstate0 }
	if "$Tp0" == "" {
		mat `sumRho' = `F'[1,1...] * J(colsof(`F'), 1, 1)
		local m = rowsof(`F')
		_mvec `Qvec' : `Q'
		mat `Pvec' = inv( I(`m'^2) - `F' # `F' ) * `Qvec'
		_mfrmvec `P' : `Pvec' , rows(`m')
	}
	else	mat `P' = $Tp0

	_kalman1 `y_pred' `y_mse' `llvar' :  /*
		*/ $Tdepvar `F' `v1' `Q' `Ap' `H' `XI' `w' `R' `P'  /*
		*/ if $ML_samp , p0

	tempname ll
	mlsum `ll' = `llvar'
/*  This message was not fully accurate and could be confusing, just report
    (backed up) from ml
	if `ll' == . {
		if "$ML_ic" != "$Tbadstic" {
			di in blue "(attempt to step into nonstationary area;"
			di in blue " solution constrained to be "  /*
			*/ "stationary and possible convergence problems)"
		}
	}
*/
end

exit

+
-
_mvec and _mfrmvec as internal matrix functions would help speed.
