*! version 5.2.0  9jun2000
program define collapse
	if _caller() < 5 {
		collaps4 `0'
		exit
	}
	version 6.0

	local n 1
	local fcn "mean"

	gettoken 1 0: 0, parse("=,[] ") match(parens)
	if "`parens'" != "" {
		local 1 `"(`1')"'
	}
	iskey `1'

	while r(key)==0 {
		gettoken 2: 0, parse("=,[] ")
		if substr(`"`1'"',1,1)=="(" {		/* is typespec */
			typespec `"`1'"'
			local fcn `"`r(type)'"'
			gettoken 1 0: 0, parse("=,[] ") match(parens)
			if "`parens'" != "" {
				local 1 `"(`1')"'
			}
		}
		else if `"`2'"'=="=" { /* is neworoldvarname=oldvarname */
			gettoken 2 0: 0, parse("=,[] ")
			gettoken 3 0: 0, parse("=,[] ")
			v_eq_v `1' `3'
			local keep `"`keep' `r(var2)'"'
			local tar `"`tar' `r(var1)'"'
			local old`n' `"`r(var2)'"'
			local fcn`n' `"`fcn'"'
			local new`n' `"`r(var1)'"'
			local fmt`n' : format `old`n''
			local n = `n'+1
			gettoken 1 0: 0, parse("=,[] ") match(parens)
			if "`parens'" != "" {
				local 1 `"(`1')"'
			}
		}
		else {			/* varlist */
			local list `"`1'"'
			local varlist "req ex"
			parse `"`list'"'
			local i 1
			local vi : word `i' of `varlist'
			while `"`vi'"' != "" {
				local keep `"`keep' `vi'"'
				local tar `"`tar' `vi'"'
				local old`n' `"`vi'"'
				local fcn`n' `"`fcn'"'
				local new`n' `"`vi'"'
				local fmt`n' : format `old`n''
				local n=`n'+1
				local i=`i'+1
				local vi : word `i' of `varlist'
			}
			gettoken 1 0: 0, parse("=,[] ") match(parens)
			if "`parens'" != "" {
				local 1 `"(`1')"'
			}
		}
		iskey `1'
	}
	local 0 `"`1' `0'"'
	local n=`n'-1
	if `n'==0 { error 198 }

	syntax [if] [in] [aw fw iw pw] [, BY(varlist) CW FAST ]

	if `"`by'"'!="" {
		bynottar `"`by'"' `"`tar'"'
	}

	if `"`weight'"' != "" {
		tempvar w
		qui gen double `w' `exp' `if' `in'
		local wgt `"[`weight'=`w']"'
	}
	tempvar touse
	mark `touse' `if' `in' `wgt'
	if `"`cw'"'!="" {
		markout `touse' `keep'
	}
	qui count if `touse'
	if r(N)==0 {
		error 2000
	}

	if `"`fast'"'=="" {
		preserve
	}
	qui keep if `touse'
	qui keep `keep' `by' `w'

					/* check uniqueness */
/*
Table:
	old`i'	(original) name of source variable		x
	use`i'  renamed old`i'
	new`i'  target variable					x
	drp`i'  =use`i' if may be dropped, else `" "'
	fcn`i'  function to call				x
	fmt`i'	%format of original variable
*/
	local i 1
	while `i' <= `n' {

		if `"`drp`i''"'=="" {
			tempname use
			local use`i' `"`use'"'
			rename `old`i'' `use'
			local lasti `i'
		}
		local j=`i'+1
		while `j'<=`n' {
			if `"`new`i''"' == `"`new`j''"' {
				di in red "error:" _n /*
				*/ _col(8) `"`new`i'' = (`fcn`i'') `old`i''"' /*
				*/ _n /*
				*/ _col(8) `"`new`j'' = (`fcn`j'') `old`j''"' /*
				*/ _n "name conflict"
				exit 198
			}
			if `"`drp`i''"'=="" & `"`old`i''"' == `"`old`j''"' {
				local lasti `j'
				local use`j' `"`use'"'
				local drp`j' `" "'
			}
			local j=`j'+1
		}
		if `"`drp`i''"'=="" {
			local drp`lasti' `"`use'"'
		}
		local i=`i'+1
	}

	quietly {
		tempvar new
		local i 1
		while `i'<=`n' {
			_`fcn`i'' `new`i'' `use`i'' `"`weight'"' `"`w'"' /*
			*/ `"`by'"'
			capture drop `drp`i''
			label var `new`i'' `"(`fcn`i'') `old`i''"'
			format `new`i'' `fmt`i''
			local i=`i'+1
		}
	}
	if `"`by'"' != "" {
		sort `by'
		quietly by `by': keep if _n==_N
	}
	else	quietly keep in 1

	global S_FN
	global S_FNDATE

	if `"`fast'"' == "" {
		restore, not
	}
end

program define bynottar /* `"byvars"' `"targetvars"' */
	local byvars `"`1'"'
	tokenize `"`2'"'
	local i 1
	local byv : word `i' of `byvars'
	while `"`byv'"' != "" {
		local j 1
		while `"``j''"' != "" {
			if `"`byv'"'==`"``j''"' {
				di in red /*
				*/ `"``j'' may not be both target and by()"'
				exit 198
			}
			local j=`j'+1
		}
		local i=`i'+1
		local byv : word `i' of `byvars'
	}
end

program define v_eq_v, rclass /* neworoldvar oldvar */
	unabbrev `2'
	ret local var2 `"`s(varlist)'"'
	capture confirm var `1'
	if _rc {
		capture confirm new var `1'
		if _rc {
			di in red `"`1' invalid variable name"'
			exit 198
		}
	}
	ret local var1 `"`1'"'
end

program define typespec, rclass /* <typespec> ) */
	tokenize `"`*'"', parse(`"() "')
	if `"`3'"' != ")" {
		unexpect `"`3'"' quote ")"
		/*NOTREACHED*/
	}
	ret local type `"`2'"'
	if `"`2'"'=="mean" | `"`2'"'=="sd" | `"`2'"'=="sum" | /*
		*/ `"`2'"'=="rawsum" { exit }
	if `"`2'"'=="count" | `"`2'"'=="max" | `"`2'"'=="min" { exit }
	if `"`2'"'=="iqr" { exit }
	if `"`2'"'=="median" {
		ret local type "p 50"
		exit
	}
	if substr(`"`2'"',1,1)=="p" {
		local x = real(substr(`"`2'"',2,.))
		if `x'>=1 & `x'<=99 & `x'==int(`x') {
			ret local type `"p `x'"'
			exit
		}
	}
	unexpect `"`2'"' noquote "mean, sd, etc."
	/*NOTREACHED*/
end

program define unexpect /* <what_found> {quote|noquote} <what_expected> */
	if `"`2'"'=="quote" {
		local q "_quote"
	}
	di in red _quote `"`1'"' _quote " found where " /*
		*/ `q' `"`3'"' `q' " expected"
	exit 198
end

program define iskey, rclass
	ret scalar key = 1
	if `"`1'"'=="" | `"`1'"'=="[" | `"`1'"'=="," { exit }
	if `"`1'"'=="if" | `"`1'"'=="in" { exit }
	ret scalar key = 0
end


/* routines for calculating statistics */

program define _mean /* newvar oldvar wtype wvar byvars */
	args y x wt w by

	if `"`w'"'=="" {
		local w 1
	}
	if `"`by'"' != "" {
		sort `by'
		local by `"by `by':"'
	}

	local ty : type `x'
	if `"`ty'"'=="double" | `"`ty'"'=="long" {
		local ty "double"
	}
	else	local ty /* erase macro */

	quietly {
		`by' gen `ty' `y' = sum(`w'*`x')/sum(cond(`x'!=.,`w',0))
		`by' replace `y' = `y'[_N]
	}
end

program define _sd /* newvar oldvar wtype wvar byvars */
	args y x wt w by

	if `"`w'"'=="" {
		local w 1
	}
	else {
		if `"`wt'"'=="pweight" {
			di in red "sd not allowed with pweights"
			exit 135
		}
	}
	if `"`by'"' != "" {
		sort `by'
		local by `"by `by':"'
	}

	quietly {
		if `"`wt'"'=="aweight" {
			tempvar new
			remakew `x' `w' `new' `"`by'"'
			local w `"`new'"'
		}

		local ty : type `x'
		if `"`ty'"'=="double" | `"`ty'"'=="long" {
			local ty "double"
		}
		else	local ty /* erase macro */

		tempvar m
		`by' gen double `m' = sum(`w'*`x')/sum(cond(`x'!=.,`w',0))
		`by' gen `ty' `y' = sqrt( /*
				*/ sum(`w'*((`x'-`m'[_N])^2)) / /*
				*/ (sum(cond(`x'!=.,`w',0))-1) /*
				*/ )
		`by' replace `y' = `y'[_N]
	}
end

program define _sum
	args y x wt w by

	if `"`w'"'=="" {
		local w 1
	}
	if `"`by'"' != "" {
		sort `by'
		local by `"by `by':"'
	}

	quietly {
		if `"`wt'"'=="aweight" {
			tempvar new
			remakew `x' `w' `new' `"`by'"'
			local w `"`new'"'
		}

		`by' gen double `y' = sum(`w'*`x')
		`by' replace `y' = `y'[_N]
	}
end

program define _rawsum
	args y x wt w by

	if `"`by'"' != "" {
		sort `by'
		local by `"by `by':"'
	}

	quietly {
		`by' gen double `y' = sum(`x')
		`by' replace `y' = `y'[_N]
	}
end

program define _count
	args y x wt w by

	if `"`by'"' != "" {
		sort `by'
		local by `"by `by':"'
	}

	quietly {
		if `"`wt'"'=="fweight" | `"`wt'"'=="iweight" /*
		*/ | `"`wt'"'=="pweight" {
			`by' gen double `y' = sum(cond(`x'!=.,`w',0))
		}
		else	`by' gen long `y' = sum(`x'!=.)
		`by' replace `y' = `y'[_N]
	}
end

program define _max
	args y x wt w by

	tempvar touse
	quietly {
		local ty : type `x'
		gen byte `touse' = (`x' != .)
		sort `by' `touse' `x'
		if `"`by'"' != "" {
			by `by': gen `ty' `y' = `x'[_N]
		}
		else	gen `ty' `y' = `x'[_N]
	}
end

program define _min
	args y x wt w by

	tempvar touse revx
	quietly {
		local ty : type `x'
		gen byte `touse' = (`x'!=.)
		gen double `revx' = -`x'
		sort `by' `touse' `revx'
		if `"`by'"' != "" {
			by `by': gen `ty' `y' = `x'[_N]
		}
		else	gen `ty' `y' = `x'[_N]
	}
end

program define _p
	args p y x wt w by

	tempvar touse i n g
	local ty : type `x'
	if `"`ty'"'=="double" | `"`ty'"'=="long" {
		local ty "double"
	}
	else	local ty /* erase macro */

	quietly {
		gen byte `touse' = `x'!=.
		sort `by' `touse' `x'

		if `"`w'"'=="" {
			local w 1
		}
		else {
			tempvar new
			if `"`by'"' != "" {
				remakew `x' `w' `new' `"by `by':"'
			}
			else	remakew `x' `w' `new'
			local w `"`new'"'
		}

		by `by' `touse': gen double `n' = sum(`w') if `touse'
		by `by' `touse': /*
			*/ gen double `g' = `n'*`p'/100 if `touse' & _n==_N
		gen long `i' = .
		by `by' `touse': /*
			*/ replace `i'=cond(`i'[_n-1]!=.,`i'[_n-1], /*
			*/ 	cond(`n'-`g'[_N]>.01,_n,.)) if `touse'
		by `by' `touse': /*
			*/ gen `ty' `y' = cond(`g'- `n'[`i'-1] >.01, /*
			*/	`x'[`i'], (`x'[`i'-1]+`x'[`i'])/2) /*
			*/	if `touse' & _n==_N

		if `"`by'"' != "" {
			by `by': replace `y' = `y'[_N]
		}
		else	replace `y' = `y'[_N]
	}
end

program define _iqr
	args y x wt w by

	tempvar p75 p25
	_p 75 `p75' `x' `"`wt'"' `"`w'"' `"`by'"'
	_p 25 `p25' `x' `"`wt'"' `"`w'"' `"`by'"'
	local ty : type `p75'
	quietly gen `ty' `y' = `p75' - `p25'
end

/* utilities used by _* routines */

program define remakew /* xvar oldw neww by-prefix */
	args x w new by
			/* by is either "" or "by vn vn ...:"	*/
	tempvar sum obs
	`by' gen long `obs' = sum(`x'!=.)
	`by' gen double `sum' = sum(cond(`x'!=.,`w',0))
	`by' gen double `new' = cond(`x'!=., `w'*`obs'[_N]/`sum'[_N], .)
end
