*! version 1.1.9  08feb2000
program define gompertz, eclass
	version 6.0
	if replay() {
		if `"`e(cmd)'"' != "gompertz" { error 301 } 
		syntax [, Level(integer $S_level) noCOEF noHEADer HR]
	}
	else {
		syntax [varlist] [if] [in] [fweight pweight iweight] /*
			*/ [, noCOEF CLuster(varname) Dead(varname numeric) /*
			*/ DEBUG FROM(string) noHEADer HR MLMethod(string) /*
			*/ MLOpt(string) noCONStant /*
			*/ Level(integer $S_level) noLOG /*
			*/ OFFset(varname numeric) /*
			*/ Robust SCore(string) T0(varname numeric) SKIP *]


		tokenize `varlist'
		local t `1'
		mac shift 
		local rhs `*'

		if "`cluster'"!="" {
			local cluopt cluster(`cluster')
		}
		if "`from'"!="" { local iniopt init(`from') }
		if "`mlmethod'" == "" { local mlmetho  "d2" }
		if "`offset'" !="" { local offopt offset(`offset') }
		mlopts options, `options'

		if "`score'" != "" {
			local n : word count `score'
			if `n' != 2 { 
				di in red /*
			*/ "score() invalid:  two new variable names required"
				exit 198 
			}
			confirm new var `score'
			local scopt "score(`score')"
		}

		if "`weight'" != "" { 
			tempvar wv
			qui gen double `wv' `exp'
			local w [`weight'=`wv']
		}

		tempvar touse 
		mark `touse' `w' `if' `in'
		markout `touse' `t' `rhs' `dead' `t0'
		markout `touse' `cluster', strok


		if "`dead'" != "" {
			local sdead "`dead'"
			capture assert `dead'==0 | `dead'==1 if `touse'
			if _rc { 
				tempvar mydead 
				qui gen byte `mydead' = `dead'!=0 if `touse'
				local dead "`mydead'"
			}
		}
		else {
			tempvar dead 
			qui gen byte `dead'=1
			local sdead 1
		}

		if "`t0'" == "" {
			local t0 0
		}
		capture assert `t0' < `t' if `touse'
		if _rc {
			di in red "`t0' >= `t' in some obs."
			exit 498
		}


		_rmcoll `rhs' `w' if `touse', `constant'
		local rhs "$S_1"
		global S_1

		global EREGd `dead'
		global EREGt0 `t0'

		if "`log'"!="" { local nlog="*" }
		tempvar num den
		tempname bc0
		quietly { 
			if "`weight'"=="aweight" | "`weight'"=="pweight" {
				tempvar wvn
				summ `wv' if `touse', meanonly 
				gen double `wvn' = `wv'/r(mean)
				local wvngen 1
			}
			else if "`weight'"!="" {
				local wvn `wv'
			}
			else {
				local wvn 1
			}
			gen double `num' = sum(`wvn'*`dead')
			gen double `den' = sum(`wvn'*(`t'-$EREGt0))
			local cons = ln(`num'[_N]/`den'[_N])
			drop `num' `den'
			gen double `num' = `wvn'*ln(`t') if `touse' & `dead'
			replace `num' = sum(`num') 
			global EREGa = `num'[_N]
			drop `num' 
			if "`wvngen'"!=""  { drop `wvn' }
		        mat `bc0' = ( `cons', 0 )    /* GAMMA = 0 */
		        mat colnames `bc0' = $EREGt:_cons gamma:_cons
		}
		if "`constant'"!="" {
			local skip = "skip"
			`nlog' di in gr "Fitting full model:"
		}

		if "`rhs'" != "" & "`skip'"=="" {
			`nlog' di ""
			`nlog' di in gr "Fitting constant-only model:"
			ml model `mlmetho' gomp_lf (`t': `t'=, `offopt' ) /*
				*/ /gamma `w' if `touse', init(`bc0')  /*
				*/ missing collin nopreserve wald(0) `mlopt' /*
				*/ max search(quietly) noout `log' `options'
			local cont continue
			`nlog' di ""
			`nlog' di in gr "Fitting full model:"
		} 
		else {
			local cont wald(1)
                }

		ml model `mlmetho' gomp_lf /*
			*/  (`t': `t'=`rhs', `offopt' `constant') /*
			*/ /gamma  `w' if `touse', `cont' noout  /*
			*/ `robust' `cluopt' `scopt' `iniopt' `mlopt' /*
			*/ missing collin nopreserve  /*
			*/ max search(off) `log' `options'

		if "`e(wtype)'" != "" {
			est local wexp `"`exp'"'
		}
		est local title "log relative-hazard form" 
		est local predict gomper_p
		est local cmd gompertz 
		est local t0 `t0'
		est local dead `sdead'
		est scalar gamma= [gamma]_b[_cons]
		global S_E_cmd gompertz
	}

	global EREGw
	global EREGd
	global EREGt
	global EREGt0
	global EREGa


	if "`coef'"=="" {
		if "`hr'"!="" {
			local hr "eform(Haz. Ratio)"
		}
		else { local hr }

		if "`header'" == "" {
			di _n in gr /*
			*/ "Gompertz regression -- entry time `e(t0)'"
			ml di, level(`level') `hr'  first
		}
		else	est di, level(`level') `hr' first
		local bg "[gamma]_b[_cons]"
		local sg "[gamma]_se[_cons]"
		local iz = invnorm(1-(1-`level'/100)/2)
		local ll = `bg'-`sg'*`iz'
		local uu = `bg'+`sg'*`iz'
		local zz = `bg'/`sg'
		di in gr   "   gamma |  "  in ye %9.0g `bg' /*
       		        */ "  " %9.0g (`sg') " " %10.3f (`zz') /*
       		        */ " " %7.3f (normprob(-abs(`zz'))*2) /*
       		        */ _col(58) %9.0g (`ll') "   " %9.0g (`uu')
		di in gr _dup(78) "-"
	}
end

exit
