*! version 2.6.0 08mar2000 
program define heckman, eclass
	version 6.0

	if replay() {
		if "`e(cmd)'" != "heckman" {
			noi di in red "results of heckman not found"
			exit 301
		}
		if "`e(method)'" == "two-step" {
			Display2 `0'
		}
		else    Display `0'
		exit
	}

	if _caller() < 6.0 {
		local vers = _caller()
		version 5
	}
	Estimate `0'
end

program define Estimate, eclass
	version 6		/* do not delete */
	if _caller() < 6.0 { 
		Parse50 `0' 
		local rhometh 0
	}
	else {
					/* Allow = after depvar */

		gettoken dep 0 : 0 , parse(" =,[")
		unab dep: `dep'
		confirm variable `dep'
		gettoken equals rest : 0 , parse(" =")
		if "`equals'" == "=" { local 0 `"`rest'"' }

					/* Primary syntax */
		syntax [varlist(default=none)] [if] [in] [pw fw iw aw]    /*
			*/ , SELect(string)    [ BRACKET CLuster(varname) /*
			*/ noCOEF  noConstant FIRst FROM(string) 	  /*
			*/ FROM0(string) Level(integer $S_level) noHEADer /*
			*/ noLOG Mills(string) MLMethod(string) 	  /*
			*/ MLOpts(string) NShazard(string) 		  /*
			*/ OFFset(varname numeric) Robust		  /*
			*/ RHOForce RHOLimited RHOSigma RHOTrunc 	  /*
			*/ SCore(string) noSKIP TECHnique(string) TWOstep * ]

					/* Set up command options. */

					/* method for rho outside -1,1 */
		local ct : word count `rhotrunc' `rholimited' `rhosigmafix' /*
			*/ `rhoforce'
		if `ct' > 1 {
			di in red "options rhotrunc, rhoforce, rholimited" /*
				*/ ", and rhosigma, are mutually exclusive"
			exit 198
		}
		if "`rhoforce'" != "" {
			local rhometh 0
		}
		else if "`rhotrunc'" != "" {
			local rhometh 1
		}
		else if "`rholimited'" != "" {
			local rhometh 3
		}
		else {				/* rhosigma is default */
			local rhometh 2		
			local rhosigm "rhosigma"
		}

		if "`score'" != "" { 
			local n : word count `score'
			if `n'==1 & substr("`score'",-1,1)=="*" { 
				local score = /*
				*/ substr("`score'",1,length("`score'")-1)
				local score `score'1 `score'2 `score'3 `score'4
				local n
			}
		}

		if "`nshazard'" != "" & "`mills'" != "" {
			di in blue "Note, options nshazard() and mills() " /*
				*/ "are synonyms, "
			di in blue "using the variable specified in nshazard()."
		}

		if "`nshazard'" != "" { local mills `nshazard' }

		local ind `varlist'

		local if0 `if'          /* Required with second -syntax- */
		local in0 `in'
		local option0 `options'
		local nc `constan'
		local off `offset'
		if "`offset'" != "" { local offopt "offset(`offset')" }

		local wtype `weight'
		local wtexp `"`exp'"'
		if "`weight'" != "" { local wgt `"[`weight'`exp']"' }

		if "`weight'" == "pweight" | "`cluster'" != "" { 
			local robust robust
		}
		if "`cluster'" != "" { local clusopt "cluster(`cluster')" }
		if "`skip'" != "" {
			if "`robust'" != "" {
di in blue "model LR test inappropriate with robust covariance estimates"
				local skip
			}
			if "`constan'" != "" {
di in blue "model LR test inappropriate with noconstant option"
				local skip
			}
			if "`ind'" == "" {
di in blue "model LR test inappropriate with constant-only model"
				local skip
			}
			if "`twostep'" != "" {
di in blue "model LR test inappropriate for two-step model"
				local skip
			}
			if "`skip'" == "" {
				di in blue "    performing Wald test instead"
			}
		}

		if "`log'" == "" {
			local showlog noisily
		} 
		else    local showlog quietly

		if "`mlmethod'" == "" { local mlmetho d2 }
		if "`mlmethod'" == "d0" {
			if "`techniq'" == "" {
				local techniq "technique(nr)"
			}
			else	local techniq "technique(`techniq')"
		}
		else if "`techniq'" != "" {
di in blue "note:  technique() only allowed with mlmethod(d0), option ignored"
			local techniq
		}

		if "`mills'" != "" { confirm new var `mills' }

					/* Setup temporary scorevars */
		if "`score'" != "" {
			local numscr : word count `score'
			if `numscr' > 4 {
di in red "number of variables in score() option must be between 1 and 4"
				exit 198
			}
			confirm new var `score'
			tempvar sc1 sc2 sc3 sc4
			local scoreml "score(`sc1' `sc2' `sc3' `sc4')"
		}

				/* Process selection equation */

					/* Set up selection depvar */

		tokenize `"`select'"', parse(" =")
		if "`1'" == "=" { local 1 " " }
		if "`2'" == "=" { 
			unab 1 : `1' 
			local seldep `1'
			
			local 1 " " 
			local 2 " " 
		}

		local 0 `*'
		syntax varlist(default=none) [, noConstant   /*
			*/ OFFset(varname numeric) ]
		local selind `varlist'

					/* Set up selection eq options. */
		local selnc `constan'
		local seloff `offset'
		if "`seloff'" != "" { local seloffo "offset(`offset')" }

				/* End process selection equation */
	}

					/* Parse ML options */
	mlopts stdopts, `option0'

					/* Ensure valid selection eqn */
	if "`selnc'" != "" & "`selind'" == "" { 
		noi di in red "no variables specified for selection"
		exit 198
	}
					/* Ensure valid main eqn */
	if "`nc'" != "" & "`ind'" == "" { 
noi di in red "must specify variables or allow constant for primary equation"
		exit 198
	}

					/* Set observed/selected variable. */
	if "`seldep'" == "" { 
		tempname seldep
		qui gen byte `seldep' =  `dep' != . 
		local selname select
	}
	else  local selname `seldep'

					/* Define sample.
					 * Best left here w/ Parse50 */
	tempvar touse rtouse
	mark `touse' `if0' `in0' `wgt'
	markout `touse' `seldep' `selind' `seloff' `cluster', strok

	qui gen byte `rtouse' = `touse'
	markout `rtouse' `dep' `ind' `off'
	qui replace `touse' = 0  if `seldep' & !`rtouse'

					/* Remove collinearity */
	_rmcoll `selind' if `touse', `selnc'
	local selind "`r(varlist)'"
	_rmdcoll `dep' `ind' if `touse' & `seldep', `nc'
	local ind "`r(varlist)'"

					/* Check selection condition */
	qui sum `seldep' if `touse'
	if `r(N)' == `r(sum)' {
di in red "Dependent variable never censored due to selection: "
di in red "model would simplify to OLS regression"
		/* regress `dep' `ind' `wgt' if `touse' */
		exit 498
	}

					/* Fetch initial values */
	if "`twostep'" == "" {
					/* Constant only model */
		if "`skip'" != "" & "`from0'" == "" {
			tempname b0
			GetIval "`dep'" "" "`nc'" "`selind'" "`selnc'" `b0' /*
				*/ "`wgt'" "`wtype'" "`wtexp'" `touse'      /*
				*/ `seldep' "`off'" "`seloffo'" "`rhometh'"
			local from0 "`b0', copy"
		}
					/* Full model.
					 * Starting values and comparison LL */
		tempname b regll prbll
		GetIval "`dep'" "`ind'" "`nc'" "`selind'" "`selnc'" /*
			*/ `b' "`wgt'" "`wtype'" "`wtexp'"          /*
			*/ `touse' `seldep' "`off'" "`seloffo'"     /*
			*/ "`rhometh'" "`twostep'" "`first'"
		scalar `regll' = r(regll)
		scalar `prbll' = r(prbll)
		if "`from'" == "" { local from "`b', copy" }
	}
	else {
					/* Do heckman's two-step procedure */

		if "`off'`seloff'`robust'`score'`cluster'`wgt'" != "" {
			di in red "weights, offset, robust, score, and cluster"
			di in red "      not allowed with the two-step option"
			exit 198
		}
		GetIval "`dep'" "`ind'" "`nc'" "`selind'" "`selnc'" "`b'"    /*
			*/ "" "" "" "`touse'" "`seldep'" "`off'" "`seloffo'" /*
			*/ "`rhometh'" "`twostep'" "`first'" "`mills'"
		Display2 , level(`level')
		if substr("`seldep'",1,2) != "__" {
			est local depvar `dep' `seldep'
		}
		else    est local depvar `dep'
		est local rhometh `rhotrunc'`rhosigmafix'`rhoforce'`rholimited'
		est local method "two-step" 
		est local cmd "heckman"
		exit					/* EXIT */
	}

	if "`skip'" == "noskip" {
					/* Fit constant only model */
		`showlog' di
		`showlog' di in green "Fitting constant-only model:"
		ml model `mlmetho' heck_d2                             /*
			*/ (`dep':  `dep' = , `nc' `offopt')           /*
			*/ (select: `seldep' = `selind', `selnc' `seloffo') /*
			*/ /athrho  /lnsigma 	                       /*
			*/ if `touse' `wgt', wald(0)                   /*
			*/ collinear missing max nooutput nopreserve   /*
			*/ init(`from0') search(off) `log' `stdopts'   /*
			*/ `mlopts' `techniq' `bracket'
		local continu "continue"
		`showlog' di
		`showlog' di in green "Fitting full model:"
	}

					/* Fit full model */
	ml model `mlmetho' heck_d2                         /*
		*/ (`dep':   `dep' = `ind', `nc' `offopt')                /*
		*/ (`selname':   `seldep' = `selind', `selnc' `seloffo')  /*
		*/ /athrho /lnsigma 			                  /*
		*/ if `touse' `wgt',                                      /*
		*/ collinear missing max nooutput nopreserve              /*
		*/ title(Heckman selection model)                         /*
		*/ `scoreml' `robust' `clusopt'                           /*
		*/ init(`from') search(off) `continu' `log' `stdopts'     /*
		*/ `mlopts' `techniq' `bracket'
	ml_s_e
	Reparm

					/* Get Mills' ratio if requested */
	if "`mills'" != "" {
		qui _predict double `mills', eq(#2), if `touse'
		qui replace `mills' = normd(`mills') / normprob(`mills')
		label var `mills' "nonselection hazard"
	}

					/* Handle scores if requested */
	if "`score'" != "" {
		tokenize `score'
		local i 1
		while "``i''" != "" {
			rename `sc`i'' ``i''
			local i = `i' + 1
		}
	}

	tokenize `e(depvar)'
	if substr("`2'", 1, 2) == "__" { est local depvar `1' }
	if "`robust'" != "" {
		est local chi2_ct "Wald"
		qui test [athrho]_b[_cons] = 0
		est scalar chi2_c = r(chi2)
	}
	else {
		est local chi2_ct "LR"
		est scalar chi2_c = 2 * (e(ll) - `regll' - `prbll')
	}
	est scalar p_c = chiprob(1, e(chi2_c))
	if "`wtype'" == "fweight" {
		tempname sumwt
		qui gen double `sumwt'`wtexp'  if `touse' & !`seldep'
		qui replace `sumwt' = sum(`sumwt')
		est scalar N_cens = `sumwt'[_N]
	}
	else {
		qui count if `seldep' == 0 & `touse'
		est scalar N_cens = r(N)
	}
	est local title2 "(regression model with sample selection)"
	est local method "ml"
	est local predict "heckma_p"
	est local mills `mills' 
	est local cmd "heckman"
	global S_E_cmd "heckman"

	Display , level(`level') `coef' `header'
end


program define Display
	syntax [, Level(integer $S_level) noCOEF noHEADer ]

	if "`coef'" == "" {
		if "`header'" == ""  { _crcshdr }
		estimates display , level(`level') neq(2) plus

		_diparm athrho, level(`level')
		_diparm lnsigma, level(`level')
		di in gr _dup(9) "-" in gr "+" _dup(69) "-"
		_diparm athrho, level(`level') tanh label("rho")
		_diparm lnsigma, level(`level') exp label("sigma")
		DiLambda `level'
		di in gr _dup(79) "-"

		if "`e(vcetype)'" != "Robust" { 
			local testtyp LR
		}
		else    local testtyp Wald
		di in gr  "`testtyp' test of indep. eqns. (rho = 0):" /*
			*/ _col(38) "chi2(" in ye "1" in gr ") = "   /*
			*/ in ye %8.2f e(chi2_c) 		     /*
			*/ _col(59) in gr "Prob > chi2 = " in ye %6.4f e(p_c)
		di in gr _dup(79) "-"
		exit e(rc)
	}
end

program define DiLambda
	args level

	tempname z lb ub

	scalar `z' = invnorm((100 + `level') / 200)
	scalar `lb' = e(lambda) - `z'*e(selambda)
	scalar `ub' = e(lambda) + `z'*e(selambda)

	local llb : di %9.0g `lb'
	if length("`llb'") > 9 {
		local lbfmt "%8.0g"
	}
	else	local lbfmt "%9.0g"

	local uub : di %9.0g `ub'
	if length("`uub'") > 9 {
		local ubfmt "%8.0g"
	}
	else	local ubfmt "%9.0g"

	di in gr _col(3) "lambda |  " /*
		*/  in ye %9.0g e(lambda) "  " %9.0g e(selambda)    /*
		*/  _col(58) `lbfmt' `lb' "   "  `ubfmt' `ub'

end


program define Display2
	syntax [, Level(integer $S_level) ]

	_crcshdr
	est display, level(`level')
        di in gr "     rho | " in ye %10.5f e(rho)
        di in gr "   sigma | " in ye %10.0g e(sigma)
	di in gr "  lambda | " in ye %10.0g e(lambda) "  " %9.0g e(selambda) 
	di in gr _dup(79) "-"
end

program define Reparm, eclass

			/* somewhat superceded by _diparm, but kept for
			 * lambda and so sigma and rho can be saved in e() */

	tempname b v d tau lns rho sig tmp lambda lamse
	mat `b' = get(_b)
	mat `v' = get(VCE)

	mat `tmp' = `b'[1,"athrho:_cons"]
	scalar `tau' = `tmp'[1,1]
	mat `tmp' = `b'[1,"lnsigma:_cons"]
	scalar `lns' = `tmp'[1,1]

	scalar `rho' = (exp(2*`tau')-1) / (exp(2*`tau')+1)
	scalar `sig' = exp(`lns')
	scalar `lambda' = `rho'*`sig'

	mat `d' =  ( `sig'*4*exp(2*`tau')/(exp(2*`tau')+1)^2 , `lambda' )
	mat `v' =  (`v'["athrho:_cons".."lnsigma:_cons",      /*
		*/   "athrho:_cons".."lnsigma:_cons"]  )
	mat `v' = `d'*`v'*`d''
	scalar `lamse' = sqrt(`v'[1,1])

	est scalar rho    = `rho'
	est scalar sigma  = `sig'
	est scalar lambda = `lambda'
	est scalar selambda  = `lamse'
	/*  Double saves for backward compatibility */
	global S_1 = `rho'
	global S_2 = `sig'
	global S_3 = `lambda'
	global S_4 = `lamse'
end


program define GetIval, rclass 
	args 	    dep		/*
		*/  ind		/*
		*/  nc		/*
		*/  selind	/*
		*/  selnc	/*
		*/  b0		/*
		*/  wgt		/*
		*/  wtype	/*
		*/  wtexp	/*
		*/  touse	/*
		*/  seldep	/* dependent variable is observed
		*/  off		/* regression offset as -offvar- 
		*/  seloffo	/* selection offset as -offset(offvar)-
		*/  rhometh	/* method of computing or handling rho
		*/  twostep	/*
		*/  first	/*
		*/  lvmills

	if "`first'" != "" { local first noisily }
	if "`twostep'" == "" { 
		local do2 "*" 
	}
	
	tempname bprb breg sigma lnsigma rho rho1 athrho Vprb deltbar wtobs
	tempvar pxb delthat mills
	qui {
					/* First-step -- probit */

		`first' probit `seldep' `selind' `wgt' /*
			*/ if `touse', asis `selnc' `seloffo'
		`do2' matrix `Vprb' = get(VCE)
		predict double `pxb', xb, if `touse'
		mat `bprb' = get(_b)
		gen double `mills' = normd(`pxb') / normprob(`pxb') 
		return scalar prbll = e(ll)

					/* Regression strictly to test indep */
		if "`off'" != ""  { 
			local origdep `dep'
			tempname dep
			gen double `dep' = `origdep' - `off'
		}
		if "`wtype'" == "aweight" {
			tempvar wt
			gen double `wt' `wtexp'
			sum `wt' if `touse', meanonly
			replace `wt' = `wt' * r(N) / r(sum)
			sum `wt'  if `touse' & `seldep'
			scalar `wtobs' = r(sum)         
			                /* required, e(N) is rounded */
			regress `dep' `ind' [iweight=`wt'], `nc', /*
				*/ if `touse' & `seldep'
		}
		else { 
			regress `dep' `ind' `wgt', `nc', if `touse' & `seldep' 
			scalar `wtobs' = e(N)
		}
		return scalar regll = -0.5 * `wtobs' * /*
			*/ ( ln(2*_pi) + ln(e(rss)/`wtobs') + 1 )

					/* Compute delta-bar */
		gen double `delthat' = `mills' * (`mills' + `pxb')
		sum `delthat' if `touse' & `seldep', meanonly
		scalar `deltbar' = r(mean)

					/* Second-step -- regression w/ Mills */
		if "`nc'" == "" {
			tempvar one
			gen byte `one' = 1
		}
    		regress `dep' `ind' `one' `mills' `wgt', nocons, /*
			*/ if `touse' & `seldep'
		mat `breg' = get(_b)

					/* Heckman's two-step consistent 
		 			 * estimates of sigma and rho */
		tempname rss ebar adj ratio
		if e(rss) == . {
			tempvar e
			predict double `e' if `touse', resid
			replace `e' = sum(`e'^2)
			scalar `rss' = `e'[_N]
		}
		else    scalar `rss' = e(rss)
		
		scalar `ebar' = `rss' / e(N)
		scalar `sigma' = sqrt(`ebar' + `deltbar'*_b[`mills']^2)

		scalar `rho' = _b[`mills'] / `sigma'
		scalar `rho1' = `rho'
		if abs(`rho') > 1 & `rhometh' >= 1 & `rhometh' <= 2 {
			scalar `rho' = `rho'/abs(`rho')
			if "`twostep'" != "" {
				noi di in blue "note, two-step estimate " /*
				*/ "of rho = "  `rho1' " is being "        /*
				*/ "truncated to " `rho'
			}
			if `rhometh' == 2 {
				scalar `sigma' = _b[`mills']*`rho'
			}
		}
		if `sigma' == 0 {scalar `sigma' = .001}
		if `rho' == . { scalar `rho' = 0 }

		if "`twostep'" != "" {
			if "`lvmills'" != "" { 
				rename `mills' `lvmills'
				local mills `lvmills'
				label var `mills' "nonselection hazard"
			}
			noi Heck2 `breg' `rho' `sigma' `bprb' `Vprb' `dep' /*
				*/ "`ind'" "`nc'" "`seldep'" "`selind'"    /*
				*/ "`selnc'" "`mills'" "`delthat'" 	   /*
				*/ "`touse'" "`rhometh'" "`rho1'"
		}
		else {
			scalar `athrho' = max(min(`rho',.85), -.85)
			scalar `athrho' = 0.5 * log((1+`athrho') / /*
				*/ (1-`athrho'))
			scalar `lnsigma' = ln(`sigma')
			mat `b0' = `breg'[1,1..(colsof(`breg')-1)] ,   /*
				*/ `bprb' , `athrho' , `lnsigma'
		}


	}
end


/*  Note:  Heck2 assumes that the regression w/ a Mills ratio is the
 *  current set of estimates */

program define Heck2, eclass   /* BetaReg rho sigma Cov(probit) 
				  RegVars RecCons PrbVars Mills touse */
	args	    b		/*  regression Beta
		*/  rho		/*  
		*/  sigma	/*
		*/  bprb	/*  probit Beta
		*/  Vprb	/*  probit VCE
		*/  dep		/*  dependent variable
		*/  ind		/*  independent varlist
		*/  nc		/*  "" or "noconstant"
		*/  seldep	/*  selection eqn dependent variable
		*/  selind	/*  selection eqn indep varlist
		*/  selnc	/*  selection eqn : "" or "noconstant"
		*/  mills	/*  Mills' ratio
		*/  delthat	/*
		*/  touse	/*  To use variable
		*/  rhometh	/*  method of using rho
		*/  rho1	/*  original two-step rho if outide -1,1 */

	tempname XpX1 F Q rho2 VBm 

	/* Compute Heckman's two-step consistent estimates of Cov */

					/* Get X'X inverse from the 
					 * second-step regression */

	if e(rmse) != 0 {
		matrix `XpX1' = get(VCE) / e(rmse)^2
	}
	else {
di in red "insufficient information in sample to estimate heckman model,"
		exit 2000
	}

					/*  Heckman's adjustment to Cov  */
	local fulnam `ind'
	if "`nc'" == "" {
		tempvar one
		g byte `one' = 1
		local fulnam "`fulnam' _cons"
	}
	local fulnam "`fulnam' lambda"
	local kreg : word count `fulnam'
	local kreg1 = `kreg' + 1
	qui mat accum `F' = `ind' `one' `mills' `selind' [iw=`delthat'], /*
		*/ `selnc', if `touse' & `seldep'
	mat `F' = `F'[1..`kreg', `kreg1'...]
	mat rowname `F' = `fulnam'
	scalar `rho2' = `rho' * `rho'
	mat `Q' = `rho2' * `F'*`Vprb'*`F''

					/* Finish the variance computation */
	tempvar rho2del
	if (`rho' < -1 | `rho' > 1) & `rhometh' == 3 { scalar `rho2' = 1 }
	qui gen double `rho2del' = 1 - `rho2' * `delthat'  if `touse'
	qui mat accum `VBm' = `ind' `one' `mills' [iw=`rho2del'], /*
		*/ nocons,  if `touse' & `seldep'
	mat `VBm' = `sigma'^2 * `XpX1' * (`VBm' + `Q') * `XpX1'

					/* Build the set of full eqn names */
	local eqnam
	tokenize `fulnam'
	local i 1
	while `i' < `kreg' {
		local eqnam `eqnam' `dep':``i''
		local i = `i' + 1
	}

	if substr("`seldep'",1,2) != "__" {
		local selname `seldep'
	}
	else    local selname select
	local kprb : word count `selind'
	local i 1
	tokenize `selind'
	while `i' <= `kprb' {
		local eqnam `eqnam' `selname':``i''
		local i = `i' + 1
	}
	if "`selnc'" == "" { 
		local eqnam `eqnam' `selname':_cons 
		local kprb = `kprb' + 1
	}
	local eqnam `eqnam' mills:lambda

					/*  Put model and selection 
					 *  equation together 
					 *  Quicker w/ matrix expr, but would
					 *  be hard to understand */

	tempname bfull Vfull zeros Vmills CovMill zeroPrb b0 bmills
	local kreg0 = `kreg' - 1
	mat `b0' = `b'[1,1..`kreg0'] 
	mat `bmills' = `b'[1,`kreg'] 
	mat `bfull' = `b0', `bprb' , `bmills'
	mat `Vmills' = `VBm'[`kreg', `kreg']
	mat `CovMill' = `VBm'[1..`kreg0', `kreg']
	mat `VBm' = `VBm'[1..`kreg0', 1..`kreg0']
	mat `zeros' = J(`kreg0', `kprb', 0)
	mat `zeroPrb' = J(`kprb', 1, 0)
	mat `VBm' = /*
		*/  ( `VBm'       , `zeros'    ,  `CovMills' \      /*
		*/    `zeros''    , `Vprb'     ,  `zeroPrb'  \      /*
		*/    `CovMills'' , `zeroPrb'' ,  `Vmills' )
	mat `VBm' = (`VBm' + `VBm'') / 2
	mat colnames `bfull' = `eqnam'
	mat rownames `VBm' = `eqnam'
	mat colnames `VBm' = `eqnam'

	qui count if `touse'
	capture est post `bfull' `VBm', obs(`r(N)')
	if _rc {
		if _rc == 506 {
			di in red "estimate of rho outside the interval "  /*
				*/ "[-1, 1] has led to a covariance matrix"
			di in red "that is not positive definite."
			* mat `VBm' = 0*`VBm'
			mat `VBm'[1, 1] = 0*`VBm'[1..`kreg0', 1..`kreg0']
		}
		est post `bfull' `VBm', obs(`r(N)')
	}

	est scalar N = `r(N)'
	capture qui test `ind', min
	if _rc == 0 {
		est scalar chi2 = `r(chi2)'
		est scalar df_m = `r(df)'
		est scalar p    = `r(p)'
	}
	qui count if `seldep' == 0 & `touse'
	est scalar N_cens = r(N)	/* early, sic */
	est local chi2type "Wald"
	est local title2 "(regression model with sample selection)"
	est local title "Heckman selection model -- two-step estimates"
	if substr("`mills'", 1, 2) != "__" { est local mills `mills' }
	est scalar rho = `rho'
	if `rho1' != `rho' { est scalar rho1 = `rho1' }
	est scalar sigma = `sigma'
	est scalar lambda = [mills]_b[lambda]
	est scalar selambda = [mills]_se[lambda]
	est local predict "heckma_p"
end

program define Parse50
	gettoken regeq  0 : 0 , parse(" ,")
	gettoken probit 0 : 0 , parse(" ,")

	syntax [if] [in] [fweight aweight] [, Level(int $S_level) /*
		*/ noConstant noLOg * ]

	eq ? `regeq'
	local regeq `r(eqname)'
	tokenize "`r(eq)'"
	local dv `1'
	if "`dv'"=="" { local dv `r(eqname)' }
	mac shift
	local vreg `*'

	eq ? `probit'
	local vprobit `r(eq)'

					/* Send things back to caller in 
					 * names used by -syntax- and caller */
	c_local dep `dv'
	c_local ind `vreg'
	c_local selind `vprobit'
	c_local nc `constan'
	c_local level `level'

	c_local log `log'
	if "`log'" == "" {
		local showlog "noisily"
	} 
	else    local showlog "quietly"
	c_local showlog `showlog'
	if "`weight'" != "" {
		c_local wtexp	`"`exp'"'
		c_local	wtype	`"`weight'"'
		c_local	wgt	`"[`weight'`exp']"'
	}
	c_local if0 `"`if'"'
	c_local in0 `in'
	c_local mlmetho d2
	c_local option0 `options'
end

exit

