*! version 3.0.4  26aug1999
program define recode 
	version 6
	gettoken vn 0 : 0
	unab vn : `vn', max(1)

	gettoken nxt : 0
	while `"`nxt'"'!="if" & `"`nxt'"'!="in" & `"`nxt'"'!="" {
		local rules `"`rules' `nxt'"'
		gettoken nxt 0 : 0 
		gettoken nxt   : 0 
	}
	if `"`rules'"'=="" { error 198 }

	syntax [if] [in]

	capture confirm string var `vn'
	if _rc==0 { error 108 }

	/* determine if the -float()- function should be used */
	capture confirm double var `vn'
	if _rc==0 { local NoFloat "nofloat" }
	capture confirm long var `vn'
	if _rc==0 { local NoFloat "nofloat" }

	quietly summ `vn' `if' `in'
	local min = r(min)
	local max = r(max)

	tokenize `"`rules'"', parse(" /=")

	/*
		Rule storage
			lhs[i]		rhs[i]		rrhs[j]
			--------------------------------------
	*/

	local i 0
	local j 1
	local nolhs 1
	while "`1'"!="" & "`1'"!="*" { 
		if "`1'"=="=" { 
			if `nolhs' { error 198 }
			mac shift 
			_crcreco "`1'" `min' `max'
			local rrhs`j' `r(s1)'
			local j = `j' + 1 
			local nolhs 1
		}
		else {
			local i=`i'+1
			local rhs`i' `j'
			_crcreco "`1'" `min' `max'
			if "`2'"=="/" { 
				local vlow `r(s1)'
				mac shift 2
				_crcreco "`1'" `min' `max'
				if "`NoFloat'" == "" {
					local lhs`i' /*
		*/ "float(`vn')>=float(`vlow') & float(`vn')<=float(`r(s1)')"
				}
				else { /* we have -long- or -double- */
					local lhs`i' /*
					*/ "`vn'>=`vlow' & `vn'<=`r(s1)'"
				}
			}
			else {
				if "`NoFloat'" == "" {
					local lhs`i' /*
					*/ "float(`vn')==float(`r(s1)')"
				}
				else { /* we have -long- or -double- */
					local lhs`i' "`vn'==`r(s1)'"
				}
			}
			local nolhs 0 
		}
		mac shift
	}
	if `nolhs'==0 { error 198 }
	local nlhs `i'	
	local nrhs = `j'- 1

/*
	di "There are `nlhs' lhs rules:"
	local i 1  
	while `i'<=`nlhs' { 
		di "`lhs`i'' -> RULE `rhs`i''"
		local i = `i' + 1
	}
	di "There are `nrhs' rhs rules:"
	local j 1 
	while `j'<=`nrhs' { 
		di "RULE `j':  `rrhs`j''"
		local j = `j' + 1
	}
*/
	if "`1'"=="*" { 
		if "`2'"!="=" | "`4'"!="" {
			error 198
		}
		_crcreco "`3'" `min' `max'
		local else `r(s1)'
	}
	tempvar NEW TOUSE ELSE
	quietly { 
		gen double `NEW' = `vn' 
		gen byte `TOUSE'=1 `if' `in'
		gen byte `ELSE' = 1
		local i 1
		while `i'<=`nlhs' { 
			replace `NEW'=`rrhs`rhs`i''' if `TOUSE'==1 & `lhs`i''
			replace `ELSE'=0 if `TOUSE'==1 & `lhs`i''
			local i = `i' + 1
		}
		if "`else'"!="" { 
			replace `NEW'=`else' if `TOUSE'==1 & `ELSE'
		}
		if "`NoFloat'" == "" {
			count if float(`vn')!=float(`NEW')
		}
		else { /* we have -long- or -double- */
			count if `vn'!=`NEW'
		}
		local i = r(N)
		replace `vn' = `NEW'
	}
	di in blu "(`i' changes made)"
end

program define _crcreco, rclass /* val min max */
	if "`1'"=="min" { ret local s1 `2' }
	else if "`1'"=="max" { ret local s1 `3' }
	else if "`1'"=="." { ret local s1 . } 
	else {
		ret local s1 `1'
		confirm number `1'
	}
end
